package sun.security.krb5.internal.crypto;

import sun.security.krb5.KrbCryptoException;
import java.security.GeneralSecurityException;
import sun.security.krb5.internal.crypto.dk.Des3DkCrypto;

public class Des3
{
    private static final Des3DkCrypto CRYPTO;
    
    private Des3() {
    }
    
    public static byte[] stringToKey(char[] salt) throws GeneralSecurityException {
        return Des3.CRYPTO.stringToKey(salt);
    }
    
    public static byte[] parityFix(byte[] value) throws GeneralSecurityException {
        return Des3.CRYPTO.parityFix(value);
    }
    
    public static int getChecksumLength() {
        return Des3.CRYPTO.getChecksumLength();
    }
    
    public static byte[] calculateChecksum(byte[] baseKey, int usage, byte[] input, int start, int len) throws GeneralSecurityException {
        return Des3.CRYPTO.calculateChecksum(baseKey, usage, input, start, len);
    }
    
    public static byte[] encrypt(byte[] baseKey, int usage, byte[] ivec, byte[] plaintext, int start, int len) throws GeneralSecurityException, KrbCryptoException {
        return Des3.CRYPTO.encrypt(baseKey, usage, ivec, null, plaintext, start, len);
    }
    
    public static byte[] encryptRaw(byte[] baseKey, int usage, byte[] ivec, byte[] plaintext, int start, int len) throws GeneralSecurityException, KrbCryptoException {
        return Des3.CRYPTO.encryptRaw(baseKey, usage, ivec, plaintext, start, len);
    }
    
    public static byte[] decrypt(byte[] baseKey, int usage, byte[] ivec, byte[] ciphertext, int start, int len) throws GeneralSecurityException {
        return Des3.CRYPTO.decrypt(baseKey, usage, ivec, ciphertext, start, len);
    }
    
    public static byte[] decryptRaw(byte[] baseKey, int usage, byte[] ivec, byte[] ciphertext, int start, int len) throws GeneralSecurityException {
        return Des3.CRYPTO.decryptRaw(baseKey, usage, ivec, ciphertext, start, len);
    }
    
    static {
        CRYPTO = new Des3DkCrypto();
    }
}
